<?xml version = "1.0" encoding="UTF-8"?>
<plugin
  id="de.grogra.blocks"
  version="2.1.3"
  xmlns="http://grogra.de/registry">

  <library file="pi6.jar" prefixes="{pi6}"/>
  <library file="raskob.jar" prefixes="{raskob}"/>
  <library file="java_cup11b.jar" prefixes="{java_cup}"/>
  <library file="3D-CS.jar" prefixes="{de.grogra.blocks}"/>

  <import plugin="de.grogra.imp3d"/>
  <import plugin="de.grogra.rgg"/>

  <registry>
	  <ref name="disable" >
			<ref name="options">
				<option name="de.grogra.blocks" type="java.lang.Boolean" value="false"/>
			</ref>
		</ref>
    <ref name="io">
      <ref name="filetypes">
        <ext name="xfr" extensions="{.xfr}" mimeType="text/x-grogra-xfr"/>
      </ref>
      <ref name="mimetypes">
        <mimetype name="text/x-grogra-xfr">
          <filter input="reader" outputClass="de.grogra.graph.impl.Node" create="de.grogra.blocks.xFrogFileParser.XFrogFilter"/>
          <filter input="freader" outputClass="de.grogra.pf.io.ProjectLoader" create="de.grogra.blocks.xFrogFileParser.XFrogProjectLoader"/>
        </mimetype>
      </ref>
    </ref>
    <ref name="objects">
      <directory name="blocks">    
        <directory name="arrangemethods">
          <factory name="Geometric"   class="de.grogra.blocks.arrangeBlock.GeometricArrange"/>
          <factory name="Halftoning"  class="de.grogra.blocks.arrangeBlock.HalftoningArrange"/>
          <factory name="Additional"  class="de.grogra.blocks.arrangeBlock.AdditionalArrange"/>
          <factory name="Probability" class="de.grogra.blocks.arrangeBlock.ProbabilityArrange"/>
        </directory>

        <directory name="probabilityarrangemethods">
          <factory name="bernoulli"  class="de.grogra.blocks.arrangeBlock.BernoulliProbability"/>
          <factory name="beta"       class="de.grogra.blocks.arrangeBlock.BetaProbability"/>          
          <factory name="betaprime"  class="de.grogra.blocks.arrangeBlock.BetaprimeProbability"/>
          <factory name="binomial"   class="de.grogra.blocks.arrangeBlock.BinomialProbability"/>
	      <factory name="cauchy"     class="de.grogra.blocks.arrangeBlock.CauchyProbability"/>	         
	      <factory name="chisquare"  class="de.grogra.blocks.arrangeBlock.ChisquareProbability"/>
          <factory name="erlang"     class="de.grogra.blocks.arrangeBlock.ErlangProbability"/>
          <factory name="f"          class="de.grogra.blocks.arrangeBlock.FProbability"/>
          <factory name="gamma"      class="de.grogra.blocks.arrangeBlock.GammaProbability"/>
          <factory name="geometric"  class="de.grogra.blocks.arrangeBlock.GeometricProbability"/>
          <factory name="invgamma"   class="de.grogra.blocks.arrangeBlock.InvgammaProbability"/>
          <factory name="logistic"   class="de.grogra.blocks.arrangeBlock.LogisticProbability"/>
          <factory name="lognormal"  class="de.grogra.blocks.arrangeBlock.LognormalProbability"/>
          <factory name="lognormal2" class="de.grogra.blocks.arrangeBlock.Lognormal2Probability"/>
          <factory name="negexp"     class="de.grogra.blocks.arrangeBlock.NegexpProbability"/>
          <factory name="normal"     class="de.grogra.blocks.arrangeBlock.NormalProbability"/>
          <factory name="normal2"    class="de.grogra.blocks.arrangeBlock.Normal2Probability"/>
          <factory name="pareto"     class="de.grogra.blocks.arrangeBlock.ParetoProbability"/>
          <factory name="pascal"     class="de.grogra.blocks.arrangeBlock.PascalProbability"/>
          <factory name="poisson"    class="de.grogra.blocks.arrangeBlock.PoissonProbability"/>
          <factory name="tstudent"   class="de.grogra.blocks.arrangeBlock.TstudentProbability"/>
          <factory name="uniform"    class="de.grogra.blocks.arrangeBlock.UniformProbability"/>
          <factory name="weibull"    class="de.grogra.blocks.arrangeBlock.WeibullProbability"/>
        </directory>
        
        <directory name="additionalarrangemethods">
          <factory name="DartThrowing"	  class="de.grogra.blocks.arrangeBlock.DartThrowing"/>
          <factory name="Voronoi_Lloyd"   class="de.grogra.blocks.arrangeBlock.Voronoi_Lloyd"/>          
          <factory name="Kachelung"       class="de.grogra.blocks.arrangeBlock.Kachelung"/>
        </directory>
      </directory>
      <ref name="math">
        <ref name="functions">
          <object name="custom" class="de.grogra.blocks.CustomFunction"/>

          <directory name="HornFunctions">
            <file name="shape" mimeType="text/x-cpfg-function"
              systemId="files/Functions/Horn/shape.func"
              type="de.grogra.xl.lang.FloatToFloat"/>
          </directory>

          <directory name="TreeFunctions">
            <file name="shape" mimeType="text/x-cpfg-function"
              systemId="files/Functions/Tree/shape.func"
              type="de.grogra.xl.lang.FloatToFloat"/>
            <file name="intensity" mimeType="text/x-cpfg-function"
              systemId="files/Functions/Tree/intensity.func"
              type="de.grogra.xl.lang.FloatToFloat"/>
            <file name="deviate" mimeType="text/x-cpfg-function"
              systemId="files/Functions/Tree/deviate.func"
              type="de.grogra.xl.lang.FloatToFloat"/>
            <file name="screw" mimeType="text/x-cpfg-function"
              systemId="files/Functions/Tree/screw.func"
              type="de.grogra.xl.lang.FloatToFloat"/>
            <file name="distribution" mimeType="text/x-cpfg-function"
              systemId="files/Functions/Tree/distribution.func"
              type="de.grogra.xl.lang.FloatToFloat"/>
            <file name="growthscale" mimeType="text/x-cpfg-function"
              systemId="files/Functions/Tree/growthscale.func"
              type="de.grogra.xl.lang.FloatToFloat"/>
            <file name="geomscale" mimeType="text/x-cpfg-function"
              systemId="files/Functions/Tree/geomscale.func"
              type="de.grogra.xl.lang.FloatToFloat"/>
            <file name="geomscaleCone" mimeType="text/x-cpfg-function"
              systemId="files/Functions/Tree/geomscaleCone.func"
              type="de.grogra.xl.lang.FloatToFloat"/>
            <file name="geomscaleSphere" mimeType="text/x-cpfg-function"
              systemId="files/Functions/Tree/geomscaleSphere.func"
              type="de.grogra.xl.lang.FloatToFloat"/>
            <file name="angle" mimeType="text/x-cpfg-function"
              systemId="files/Functions/Tree/angle.func"
              type="de.grogra.xl.lang.FloatToFloat"/>
            <file name="dense" mimeType="text/x-cpfg-function"
              systemId="files/Functions/Tree/dense.func"
              type="de.grogra.xl.lang.FloatToFloat"/>
          </directory>
                
          <directory name="ArrangeFunctions">
            <file name="scale" mimeType="text/x-cpfg-function"
              systemId="files/Functions/Arrange/scale.func"
              type="de.grogra.xl.lang.FloatToFloat"/>
            <file name="spin" mimeType="text/x-cpfg-function"
              systemId="files/Functions/Arrange/spin.func"
              type="de.grogra.xl.lang.FloatToFloat"/>
            <file name="slope" mimeType="text/x-cpfg-function"
              systemId="files/Functions/Arrange/slope.func"
              type="de.grogra.xl.lang.FloatToFloat"/>
          </directory>

          <directory name="HydraFunctions">
            <file name="slopeHydra" mimeType="text/x-cpfg-function"
              systemId="files/Functions/Hydra/slopeHydra.func"
              type="de.grogra.xl.lang.FloatToFloat"/>
            <file name="slopeWreath" mimeType="text/x-cpfg-function"
              systemId="files/Functions/Hydra/slopeWreath.func"
              type="de.grogra.xl.lang.FloatToFloat"/>
          </directory>
        </ref>
        <ref name="curves">
          <directory name="TreeCurves">
            <file name="trajectory" mimeType="text/x-cpfg-contour"
              systemId="files/Functions/Tree/trajectory.con"
              type="de.grogra.math.BSplineCurve"/>
            <file name="crookedness" mimeType="text/x-cpfg-contour"
              systemId="files/Functions/Tree/crookedness.con"
              type="de.grogra.math.BSplineCurve"/>
            <file name="deviateC" mimeType="text/x-cpfg-contour"
              systemId="files/Functions/Tree/deviateC.con"
              type="de.grogra.math.BSplineCurve"/>              
          </directory>
        </ref>
      </ref>
    </ref>
    <ref name="ui">
      <ref name="editors">
        <directory name="blocks">       
	         <poly name="arrangemethods"    type="de.grogra.blocks.arrangeBlock.ArrangeMethod" directory="/objects/blocks/arrangemethods"/>
	         <composite name="Geometric"    type="de.grogra.blocks.arrangeBlock.GeometricArrange"   fields="{method,number,level}"/>
	         <composite name="Halftoning"   type="de.grogra.blocks.arrangeBlock.HalftoningArrange"  fields="{method, threshold, maxThreshold}"/>
	         <composite name="Additional"   type="de.grogra.blocks.arrangeBlock.AdditionalArrange"  fields="{method}"/>
	         <composite name="Probability"  type="de.grogra.blocks.arrangeBlock.ProbabilityArrange" fields="{method,level,minRadius,hierarchic}"/>
	         
	         <poly name="probabilityarrangemethods"   type="de.grogra.blocks.arrangeBlock.ProbabilityArrangeMethod" directory="/objects/blocks/probabilityarrangemethods"/>
	         <composite name="bernoulli"   type="de.grogra.blocks.arrangeBlock.BernoulliProbability"   fields="{prob}"/>
	         <composite name="beta"        type="de.grogra.blocks.arrangeBlock.BetaProbability"        fields="{shape_a, shape_b}"/>	         
	         <composite name="betaprime"   type="de.grogra.blocks.arrangeBlock.BetaprimeProbability"   fields="{shape_a, shape_b}"/>	         
	         <composite name="binomial"    type="de.grogra.blocks.arrangeBlock.BinomialProbability"    fields="{prob, trials}"/>
	         <composite name="cauchy"      type="de.grogra.blocks.arrangeBlock.CauchyProbability"      fields="{median, scale}"/>	         
	         <composite name="chisquare"   type="de.grogra.blocks.arrangeBlock.ChisquareProbability"   fields="{deg_freedom}"/>
	         <composite name="erlang"      type="de.grogra.blocks.arrangeBlock.ErlangProbability"      fields="{scale, shape}"/>
	         <composite name="f"           type="de.grogra.blocks.arrangeBlock.FProbability"           fields="{num_deg_freedom, den_deg_freedom}"/>
   	         <composite name="gamma"       type="de.grogra.blocks.arrangeBlock.GammaProbability"       fields="{scale, shape}"/>
	         <composite name="geometric"   type="de.grogra.blocks.arrangeBlock.GeometricProbability"   fields="{prob}"/>
	         <composite name="invgamma"    type="de.grogra.blocks.arrangeBlock.InvgammaProbability"    fields="{scale, shape}"/>
	         <composite name="logistic"    type="de.grogra.blocks.arrangeBlock.LogisticProbability"    fields="{location, scale}"/>
	         <composite name="lognormal"   type="de.grogra.blocks.arrangeBlock.LognormalProbability"   fields="{mean, variance}"/>
	         <composite name="lognormal2"  type="de.grogra.blocks.arrangeBlock.Lognormal2Probability"  fields="{mean, variance}"/>
	         <composite name="negexp"      type="de.grogra.blocks.arrangeBlock.NegexpProbability"      fields="{mean}"/>
	         <composite name="normal"      type="de.grogra.blocks.arrangeBlock.NormalProbability"      fields="{mean, variance}"/>
	         <composite name="normal2"     type="de.grogra.blocks.arrangeBlock.Normal2Probability"     fields="{mean, std_dev}"/>
	         <composite name="pareto"      type="de.grogra.blocks.arrangeBlock.ParetoProbability"      fields="{scale, shape}"/>
	         <composite name="pascal"      type="de.grogra.blocks.arrangeBlock.PascalProbability"      fields="{prob, successes}"/>
	         <composite name="poisson"     type="de.grogra.blocks.arrangeBlock.PoissonProbability"     fields="{mean}"/>
	         <composite name="tstudent"    type="de.grogra.blocks.arrangeBlock.TstudentProbability"    fields="{deg_freedom}"/>
	         <composite name="uniform"     type="de.grogra.blocks.arrangeBlock.UniformProbability"     fields="{min, max}"/>
	         <composite name="weibull"     type="de.grogra.blocks.arrangeBlock.WeibullProbability"     fields="{scale, shape}"/>

	         <poly name="additionalarrangemethods"   type="de.grogra.blocks.arrangeBlock.AdditionalArrangeMethod" directory="/objects/blocks/additionalarrangemethods"/>
	         <composite name="DartThrowing"	  type="de.grogra.blocks.arrangeBlock.DartThrowing"   fields="{number, minRadius}"/>
	         <composite name="Voronoi_Lloyd"  type="de.grogra.blocks.arrangeBlock.Voronoi_Lloyd"  fields="{number, anzIterationen}"/>
	         <composite name="Kachelung"      type="de.grogra.blocks.arrangeBlock.Kachelung"      fields="{number, minRadius, level, checkBorders}"/>
			 
			 <composite name="custom" type="de.grogra.blocks.CustomFunction"  fields="{function, p}"/> 
        </directory>
      </ref>
    </ref>

   
  </registry>
</plugin>
